#include <stdio.h>
#include <windows.h>
#include <string.h>
#include <stdlib.h>

#include "code.h"
#include "cdemo.h"

BARCODE bc;

long FAR PASCAL _export WndProc(HWND hWnd,
											  unsigned wMsg,
											  unsigned int wParam,
											  LONG lParam);

HDC GetPrinterDC (char *lpszDevice, char *lpszDriver, char *lpszPort)
{
	static char szPrinter [80];
	char *szDevice, *szDriver, *szOutput;

	GetProfileString ("windows", "device", ",,,", szPrinter, 80);
	if (NULL != (szDevice = strtok (szPrinter, ",")) &&
		 NULL != (szDriver = strtok (NULL,      ",")) &&
		 NULL != (szOutput = strtok (NULL,      ",")))
	{
		if (lpszDevice != NULL)
			strcpy (lpszDevice, szDevice);
		if (lpszDriver != NULL)
			strcat (strcpy (lpszDriver, szDriver), ".DRV");
		if (lpszPort != NULL)
			strcpy (lpszPort, szOutput);
		return CreateDC (szDriver, szDevice, szOutput, NULL);
	}
	return 0;
}

#pragma argsused
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR
lpCmdLine, int nCmdShow)
{
	char szAppName[] = "FIT:BC:MAIN";
	HANDLE      hAccel;
	WNDCLASS wndclass;
	MSG msg;
	HWND hWndMain;

	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon (hInstance, "BARCODE");
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = COLOR_WINDOW + 1;
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = szAppName;
	RegisterClass (&wndclass);

	hWndMain = CreateWindow(szAppName, "",
		WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
		CW_USEDEFAULT, CW_USEDEFAULT,
		CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, hInstance,NULL);

	ShowWindow (hWndMain, nCmdShow);
	UpdateWindow (hWndMain);

	hAccel = LoadAccelerators (hInstance, "TASTEN");

	while (GetMessage (&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator (hWndMain, hAccel, &msg))
		{
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
	}
	return 0;
}

#pragma argsused
long FAR PASCAL _export WndProc(HWND hWnd,
											  unsigned wMsg,
											  unsigned int wParam,
											  LONG lParam)
{
	static char lpszCode[60] = "", lpszExtra[6] = "";
	static int nHoehe, nBreite;
	static HMENU hm;

	HDC hDC;
	PAINTSTRUCT ps;
	char szWT[50];
	char sHoehe[10];
	int nModule;

	switch(wMsg) {
		case WM_CREATE :
			GetPrivateProfileString("BARCODE", "Code", "1234567",
				lpszCode, 60, "bc.ini");
			GetPrivateProfileString("BARCODE", "Extra", "10",
				lpszExtra, 6, "bc.ini");
			hm = GetSystemMenu (hWnd, FALSE);
			AppendMenu (hm, MF_SEPARATOR, NULL, NULL);
			AppendMenu (hm, MF_STRING, ID_TC, "&Text mit Checksumme");
			AppendMenu (hm, MF_STRING, ID_CS, "&Checksumme");
			bc.byBarcode = BCID_UPC;
			bc.nFlags = BC_SHOWCODETEXT | BC_ALIGNCENTER | BC_MODWIDTH;
			bc.rcBorder.left = 10;
			bc.rcBorder.right = 5;
			bc.rcBorder.top = 10;
			bc.rcBorder.bottom = 5;
			bc.nBlankWidth = 10;
			bc.fRatio = 2.0;
			bc.nFlowVariables = 100;
			bc.lCodeColor = RGB (0, 0, 0);
			bc.lBKColor = RGB (255, 255, 255);
			strcpy (bc.szFont, "OCR");
			bc.nFontHeight = 8;
			bc.nBlankHeight = 3;
			sprintf (szWT, "Demo barcode.dll - %d", bc.byBarcode);
			SetWindowText (hWnd, szWT);
			break;

		case WM_SIZE :
			nBreite = LOWORD(lParam);
			nHoehe = HIWORD(lParam);
			nModule = GetModules (lpszCode, lpszExtra, &bc);
			if (bc.nFlags & BC_CODEWIDTH) {
				bc.nWidth = nBreite;
			}
			else {
				bc.nWidth = nBreite / nModule;
			}
			bc.nHeight = nHoehe-
				(bc.rcBorder.top+bc.rcBorder.bottom)*nBreite/nModule;
			break;

		case WM_CLOSE :
			DestroyWindow (hWnd);
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		case WM_PAINT :
			hDC = BeginPaint (hWnd, &ps);
			nModule = GetModules (lpszCode, lpszExtra, &bc);
			WritePrivateProfileString ("BARCODE", "Module",
				itoa (nModule, szWT, 10), "bc.ini");
			DrawBarcode (hDC, 0, 0, lpszCode, lpszExtra, &bc);
			EndPaint (hWnd, &ps);
			break;

		case WM_LBUTTONDOWN :
			bc.byBarcode = (bc.byBarcode+1) % (BCID_END - BCID_START);
			nModule = GetModules (lpszCode, lpszExtra, &bc);
			if (bc.nFlags & BC_CODEWIDTH) {
				bc.nWidth = nBreite;
			}
			else {
				bc.nWidth = nBreite / nModule;
			}
			bc.nHeight = nHoehe-
				(bc.rcBorder.top+bc.rcBorder.bottom)*nBreite/nModule;
			sprintf (szWT, "Demo barcode.dll - %d", bc.byBarcode);
			SetWindowText (hWnd, szWT);
			InvalidateRect (hWnd, NULL, TRUE);
			break;

		case WM_RBUTTONDOWN :
			bc.nWidth *= 2;
			bc.nHeight *= 2;
			hDC = GetPrinterDC (NULL, NULL, NULL);
			Escape (hDC, STARTDOC, 12, "BARCODE-TEST", NULL);
			DrawBarcode (hDC, 0, 0, lpszCode, lpszExtra, &bc);
			Escape (hDC, NEWFRAME, 0, NULL, NULL);
			Escape (hDC, ENDDOC, 0, NULL, NULL);
			DeleteDC (hDC);
			bc.nWidth = nBreite;
			bc.nHeight = nHoehe-100;
			break;

		case WM_SYSCOMMAND:
			switch ( wParam )	{
				case ID_TC :
					if (bc.nFlags & BC_SHOWCHECKSUM)
					{
						bc.nFlags &= ~BC_SHOWCHECKSUM;
						CheckMenuItem (hm, ID_TC, MF_BYCOMMAND | MF_UNCHECKED);
					}
					else
					{
						bc.nFlags |= BC_SHOWCHECKSUM;
						CheckMenuItem (hm, ID_TC, MF_BYCOMMAND | MF_CHECKED);
					}
					InvalidateRect (hWnd, NULL, TRUE);
					return 0;

				case ID_CS :
					if (bc.nFlags & BC_CHECKSUM)
					{
						bc.nFlags &= ~BC_CHECKSUM;
						CheckMenuItem (hm, ID_CS, MF_BYCOMMAND | MF_UNCHECKED);
					}
					else
					{
						bc.nFlags |= BC_CHECKSUM;
						CheckMenuItem (hm, ID_CS, MF_BYCOMMAND | MF_CHECKED);
					}
					InvalidateRect (hWnd, NULL, TRUE);
					return 0;
			}
	}
	return DefWindowProc (hWnd, wMsg, wParam, lParam);
}

