#ifndef __BARCODE_H
	#define __BARCODE_H

#ifndef __WINDOWS_H
	#include <windows.h>
#endif

#define BCID_START                  0x00
#define BCID_2_5_INDUSTRIAL         0x00
#define BCID_2_5_INTERLEAVED        0x01
#define BCID_2_5_MATRIX             0x02
#define BCID_CODABAR                0x03
#define BCID_39                     0x04
#define BCID_93                     0x05
#define BCID_128                    0x06
#define BCID_EAN                    0x07
#define BCID_UPC							0x08
#define BCID_END                    0x09

#define BCA_MODULES					 0x0001

/*
#define BCI_TEXT_CODENAME         0x0010
#define BCI_TEXT_RATIO            0x0020
#define BCI_TEXT_POSSIBLECHAR     0x0030
#define BCI_TEXT_PROSCONS         0x0040
#define BCI_TEXT_FULLTEXT         0x0050

#define BC_TESTFIGURE             0x0100
#define BC_LENGTH                 0x0200
#define BC_ID                     0x0300
#define BC_LIST                   0x0400

#define BC_OFF_CODENAME 	       0x0000
#define BC_OFF_PROANDCONS         0x0010
#define BC_OFF_POSSIBLECHAR       0x0020
#define BC_OFF_TESTFIGURE         0x0030
#define BC_OFF_LENGTH             0x0040
#define BC_OFF_MINWIDTH           0x0050
#define BC_OFF_MAXWIDTH           0x0060
#define BC_OFF_EXAMPLE            0x0070
#define BC_OFF_EXTRACODE          0x0080
*/
#define BC_MODWIDTH               0x0000  // Breitenfeld gibt Modulbreite an
#define BC_CODEWIDTH					 0x0001	// Breitenfeld gibt Barcodebreite an
#define BC_NOCHECKSUM             0x0000  // Checksumme nicht berechnen
#define BC_CHECKSUM					 0x0002	// Checksumme berechnen
#define BC_SHOWCODETEXT				 0x0004	// Nutzinformation als Text anzeigen
#define BC_SHOWCHECKSUM				 0x0008	// Nutzinformation und Prfziffer als Text anzeigen
#define BC_INVERTED               0x0010	// Barcode invertieren
#define BC_ALIGNCENTER            0x0000  // Text zentriert ausgeben
#define BC_ALIGNLEFT					 0x0100  // Text linksbndig ausgeben
#define BC_ALIGNRIGHT             0x0200  // Text rechtsbndig ausgeben
#define BC_ALIGNTOP               0x0400  // Text oberhalb des Barcodes anzeigen
#define BC_ALIGNBOTTOM            0x0000  // Text unterhalb des Barcodes anzeigen

typedef struct tagBARCODE
{
	int byBarcode;       // ID des Barcodes (Aus Headerdatei)
	int nFlags;          // Bit Bedeutung
								//  0  nBreite gibt Modulbreite (0) bzw. Barcodebreite (1) an
								//  1  Prfziffer soll mit ausgegeben werden (1)
								//  2  Beschriftung soll mit ausgegeben werden (1)
								//  3  Beschriftung soll die Prfziffer mit darstellen (1)
								//  4  Der Barcode soll invers werden (1)
								//  5-15 momentan unbenutzt
	RECT rcBorder;       // left   = Abstand links vom Barcode in Modulen
								// right  = Abstand rechts vom Barcode in Modulen
								// top    = Abstand oberhalb des Barcodes in Modulen
								// bottom = Abstand unterhalb des Barcodes in Modulen
	int nBlankWidth;     // Breite des Abstandes zwischen Code und Add-on in Modulen
	int nWidth;          // Breite eines Moduls bzw. des Barcodes in virtuellen Einheiten
	int nHeight;			// Hoehe des Barcodes (inkl. Schrift aber ohne Rand) in virtuellen Einheiten
	float fRatio;        // Breitenverhaeltnis fr Zweibreitencodes
	int nFlowVariables;  // Wie breit soll ein schwarzes Element gezeichnet werden (0-100%)
	COLORREF lCodeColor; // Farbe der Striche und der Schrift
	COLORREF lBKColor;   // Hintergrundfarbe
	char szFont[LF_FACESIZE]; // Name des Schriftfonts
	int nFontHeight;		// Hoehe der Schrift in Modulen
	int nBlankHeight;		// Hoehe des Abstandes zwischen Code und Schrift in Modulen
} BARCODE;

#ifdef __cplusplus
extern "C" {
#endif

// int FAR PASCAL _export BarcodeAction (BC *lpBarcode, WORD Aktion, LONG *lParam);

BOOL FAR PASCAL _export DrawBarcode (HDC, int, int, LPSTR, LPSTR, BARCODE far *);
int FAR PASCAL _export GetModules (LPSTR, LPSTR, BARCODE far *);

#ifdef  __cplusplus
}
#endif

#endif
